%define sssdstatedir %{_localstatedir}/lib/sss
%define dbpath %{sssdstatedir}/db
%define pipepath %{sssdstatedir}/pipes
%define mcpath %{sssdstatedir}/mc
%define pubconfpath %{sssdstatedir}/pubconf

%define ipamajor 0
%define ipalibname %mklibname ipa_hbac %{ipamajor}
%define ipalibnamedev %{_lib}ipa_hbac

%define Werror_cflags %nil

Name:       sssd
Version:    1.9.4
Release:    %mkrel 2
Group:      System/Libraries
Summary:    System Security Services Daemon
License:    GPLv3+
URL:        http://fedorahosted.org/sssd/
Source0:    https://fedorahosted.org/released/sssd/%{name}-%{version}.tar.gz
Source1:    sssd.conf
Patch1:	    0001-krb-recreate-ccache-if-it-was-deleted.patch
Patch2:	    0002-Don-t-use-srcdir-with-tests.patch
Patch3:	    0003-krb5-include-backwards-compatible-declaration-of-krb.patch
Patch4:	    0004-subdomains-replace-invalid-characters-with-underscor.patch
Patch5:	    0501-FEDORA-Switch-the-default-ccache-location.patch
Patch6:	    sssd-1.9.4-CVE-2013-0287-1.patch
Patch7:	    sssd-1.9.4-CVE-2013-0287-2.patch
Patch8:	    sssd-1.9.4-CVE-2013-0287-3.patch
Patch9:	    sssd-1.9.4-CVE-2013-0287-4.patch
Requires: sssd-client = %{version}-%{release}
Requires: sasl-plug-gssapi
BuildRequires: popt-devel
BuildRequires: talloc-devel
BuildRequires: tevent-devel
BuildRequires: tdb-devel
BuildRequires: ldb-devel
BuildRequires: ldb-utils
BuildRequires: libnl-devel
BuildRequires: semanage-devel
BuildRequires: dbus-devel
BuildRequires: openldap-devel
BuildRequires: pam-devel
BuildRequires: nss-devel
BuildRequires: nspr-devel
BuildRequires: pcre-devel
BuildRequires: xsltproc
BuildRequires: libxml2
BuildRequires: docbook-style-xsl
BuildRequires: docbook-dtd44-xml
BuildRequires: krb5-devel >= 1.10
BuildRequires: c-ares-devel
BuildRequires: python-devel
BuildRequires: check-devel
BuildRequires: doxygen
BuildRequires: keyutils-devel
BuildRequires: bind-utils
BuildRequires: dhash-devel
BuildRequires: collection-devel
BuildRequires: ini_config-devel
BuildRequires: path_utils-devel
BuildRequires: libunistring-devel
BuildRequires: selinux-devel
BuildRequires: glib2-devel
BuildRequires: gettext-devel

%description
Provides a set of daemons to manage access to remote directories and
authentication mechanisms. It provides an NSS and PAM interface toward
the system and a pluggable backend system to connect to multiple different
account sources. It is also the basis to provide client auditing and policy
services for projects like FreeIPA.

%package client
Summary:    SSSD Client libraries for NSS and PAM
Group:      System/Libraries
License:    LGPLv3+

%description client
Provides the libraries needed by the PAM and NSS stacks to connect to the SSSD
service.

%package tools
Summary:    Userspace tools for use with the SSSD
Group:      System/Libraries
License:    GPLv3+
Requires:   sssd = %{version}-%{release}

%description tools
Provides userspace tools for manipulating users, groups, and nested groups in
SSSD when using id_provider = local in /etc/sssd/sssd.conf.

Also provides several other administrative tools:
    * sss_debuglevel to change the debug level on the fly
    * sss_seed which pre-creates a user entry for use in kickstarts
    * sss_obfuscate for generating an obfuscated LDAP password

%package %ipalibname
Summary: FreeIPA HBAC Evaluator library
Group: System/Libraries
License: LGPLv3+

%description %ipalibname
Utility library to validate FreeIPA HBAC rules for authorization requests

%package %ipalibnamedev
Summary: FreeIPA HBAC Evaluator library
Group: System/Libraries
License: LGPLv3+

%description %ipalibnamedev
Utility library to validate FreeIPA HBAC rules for authorization requests

%package -n libsss_autofs
Summary: A library to allow communication between Autofs and SSSD
Group: System/Libraries
License: LGPLv3+

%description -n libsss_autofs
A utility library to allow communication between Autofs and SSSD

%package -n libsss_sudo
Summary: A library to allow communication between SUDO and SSSD
Group: System/Libraries
License: LGPLv3+
Requires: sssd = %{version}-%{release}

%description -n libsss_sudo
A utility library to allow communication between SUDO and SSSD

%package -n libsss_sudo-devel
Summary: A library to allow communication between SUDO and SSSD
Group: System/Libraries
License: LGPLv3+
Requires: libsss_sudo = %{version}-%{release}

%description -n libsss_sudo-devel
A utility library to allow communication between SUDO and SSSD

%prep
%setup -q
%apply_patches

%build
autoreconf -ivf
%configure2_5x \
    --with-db-path=%{dbpath} \
    --with-pipe-path=%{pipepath} \
    --with-pubconf-path=%{pubconfpath} \
    --with-mcache-path=%{mcpath} \
    --with-init-dir=%{_initrddir} \
    --with-krb5-rcache-dir=%{_localstatedir}/cache/krb5rcache \
    --with-default-ccache-dir=/run/user/%U \
    --with-default-ccname-template=DIR:%d/krb5cc \
    --enable-nsslibdir=/%{_lib} \
    --enable-pammoddir=/%{_lib}/security \
    --disable-static \
    --disable-rpath
%make

%check
# %%__make check

%install
rm -rf %{buildroot}
rm -f *.lang

%makeinstall_std

# Prepare language files
%find_lang sssd

# Copy default sssd.conf file
install -d -m 755 %{buildroot}%{_sysconfdir}/sssd
install -m 600 %{SOURCE1} %{buildroot}%{_sysconfdir}/sssd/sssd.conf

# Copy default logrotate file
install -D -m 644 src/examples/logrotate \
    %{buildroot}%{_sysconfdir}/logrotate.d/sssd

# Make sure SSSD is able to run on read-only root
install -D -m 644 src/examples/rwtab %{buildroot}%{_sysconfdir}/rwtab.d/sssd

# Replace sysv init script with systemd unit file
rm -f %{buildroot}%{_initrddir}/%{name}
install -D -m 644 src/sysv/systemd/sssd.service \
    %{buildroot}%{_unitdir}/sssd.service

# Remove .la files created by libtool
find %{buildroot} -name \*.la | xargs rm -f

touch sssd_tools.lang
touch sssd_client.lang
for man in `find %{buildroot}%{_mandir}/??/man?/ -type f | sed -e "s#%{buildroot}%{_mandir}/##"`; do
    lang=`echo $man | cut -c 1-2`
    case `basename $man` in
        sss_cache*)
            echo \%lang\(${lang}\) \%{_mandir}/${man}\* >> sssd.lang
            ;;
        sss_*)
            echo \%lang\(${lang}\) \%{_mandir}/${man}\* >> sssd_tools.lang
            ;;
        sssd_krb5_*)
            echo \%lang\(${lang}\) \%{_mandir}/${man}\* >> sssd_client.lang
            ;;
        pam_sss*)
            echo \%lang\(${lang}\) \%{_mandir}/${man}\* >> sssd_client.lang
            ;;
        sssd_krb5_locator_plugin*)
            echo \%lang\(${lang}\) \%{_mandir}/${man}\* >> sssd_client.lang
            ;;
        *)
            echo \%lang\(${lang}\) \%{_mandir}/${man}\* >> sssd.lang
            ;;
    esac
done

%post
%_post_service %{name}

%preun
%_preun_service %{name}

%files -f sssd.lang
%doc COPYING
%{_unitdir}/sssd.service
%{_sbindir}/sssd

%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/krb5_child
%{_libexecdir}/%{name}/ldap_child
%{_libexecdir}/%{name}/proxy_child
%{_libexecdir}/%{name}/sssd_be
%{_libexecdir}/%{name}/sssd_nss
%{_libexecdir}/%{name}/sssd_pam
%{_libexecdir}/%{name}/sssd_autofs
%{_libexecdir}/%{name}/sssd_ssh
%{_libexecdir}/%{name}/sssd_sudo

%dir %{_libdir}/%{name}
%{_libdir}/%{name}/libsss_ipa.so
%{_libdir}/%{name}/libsss_krb5.so
%{_libdir}/%{name}/libsss_ldap.so
%{_libdir}/%{name}/libsss_proxy.so
%{_libdir}/%{name}/libsss_simple.so
%{_libdir}/%{name}/libsss_ad.so

%{_libdir}/ldb/memberof.so
%{_bindir}/sss_ssh_authorizedkeys
%{_bindir}/sss_ssh_knownhostsproxy
%{_sbindir}/sss_cache

%dir %{sssdstatedir}
%dir %{_localstatedir}/cache/krb5rcache
%attr(700,root,root) %dir %{dbpath}
%attr(755,root,root) %dir %{pipepath}
%attr(755,root,root) %dir %{pubconfpath}
%attr(700,root,root) %dir %{pipepath}/private
%attr(750,root,root) %dir %{_var}/log/%{name}
%attr(700,root,root) %dir %{_sysconfdir}/sssd
%config(noreplace) %{_sysconfdir}/sssd/sssd.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/sssd
%config(noreplace) %{_sysconfdir}/rwtab.d/sssd
%{_datadir}/sssd
%{_mandir}/man1/sss_ssh_authorizedkeys.1*
%{_mandir}/man1/sss_ssh_knownhostsproxy.1*
%{_mandir}/man5/sssd.conf.5*
%{_mandir}/man5/sssd-ipa.5*
%{_mandir}/man5/sssd-krb5.5*
%{_mandir}/man5/sssd-ldap.5*
%{_mandir}/man5/sssd-simple.5*
%{_mandir}/man5/sssd-ad.5*
%{_mandir}/man5/sssd-sudo.5*
%{_mandir}/man8/sssd.8*
%{_mandir}/man8/sss_cache.8*
%{python_sitearch}/*.so
%{python_sitelib}/SSSDConfig
%{python_sitelib}/SSSDConfig-%{version}-py%pyver.egg-info

%files client -f sssd_client.lang
%doc src/sss_client/COPYING src/sss_client/COPYING.LESSER
/%{_lib}/libnss_sss.so.2
/%{_lib}/security/pam_sss.so
%{_libdir}/krb5/plugins/libkrb5/sssd_krb5_locator_plugin.so
%{_mandir}/man8/pam_sss.8*
%{_mandir}/man8/sssd_krb5_locator_plugin.8*

%files tools -f sssd_tools.lang
%doc COPYING
%{_sbindir}/sss_useradd
%{_sbindir}/sss_userdel
%{_sbindir}/sss_usermod
%{_sbindir}/sss_groupadd
%{_sbindir}/sss_groupdel
%{_sbindir}/sss_groupmod
%{_sbindir}/sss_groupshow
%{_sbindir}/sss_obfuscate
%{_sbindir}/sss_debuglevel
%{_sbindir}/sss_seed
%{_mandir}/man8/sss_groupadd.8*
%{_mandir}/man8/sss_groupdel.8*
%{_mandir}/man8/sss_groupmod.8*
%{_mandir}/man8/sss_groupshow.8*
%{_mandir}/man8/sss_useradd.8*
%{_mandir}/man8/sss_userdel.8*
%{_mandir}/man8/sss_usermod.8*
%{_mandir}/man8/sss_obfuscate.8*
%{_mandir}/man8/sss_debuglevel.8*
%{_mandir}/man8/sss_seed.8*

%files %ipalibname
%_libdir/*.so.%{ipamajor}
%_libdir/*.so.%{ipamajor}.*

%files %ipalibnamedev
%_includedir/*
%_libdir/pkgconfig/*.pc
%_libdir/*.so

%files -n libsss_sudo
%doc src/sss_client/COPYING src/sss_client/COPYING.LESSER
%{_libdir}/libsss_sudo.so*

%files -n libsss_sudo-devel
%{_includedir}/sss_sudo.h

%files -n libsss_autofs
%doc src/sss_client/COPYING src/sss_client/COPYING.LESSER
%{_libdir}/sssd/modules/libsss_autofs.so*



%changelog

* Wed Mar 20 2013 luigiwalser <luigiwalser> 1.9.4-2.mga3
+ Revision: 404186
- add upstream patches to fix CVE-2013-0287

* Fri Feb 15 2013 luigiwalser <luigiwalser> 1.9.4-1.mga3
+ Revision: 398567
- BR gettext-devel for autoreconf
- 1.9.4
- add patches from fedora to fix build and other issues

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Mon Dec 31 2012 guillomovitch <guillomovitch> 1.9.3-1.mga3
+ Revision: 336684
- new version

* Sat Dec 01 2012 fwang <fwang> 1.7.0-2.mga3
+ Revision: 323909
- br selinux

* Tue Mar 20 2012 tmb <tmb> 1.7.0-2.mga2
+ Revision: 225041
- rebuild against libnl3

* Thu Jan 26 2012 nanardon <nanardon> 1.7.0-1.mga2
+ Revision: 201914
- disable test (don't pass on bs)
- 1.7.0

  + dmorgan <dmorgan>
    - imported package sssd

